/* 
 *  arch-tag: Header for gmencoder engine
 *
 *  Copyright (C) 2007 INdT - Renato Filho <renato.filho@indt.org.br>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 */

#ifndef __G_MENCODER_H__
#define __G_MENCODER_H__

#include <glib-object.h>

G_BEGIN_DECLS typedef struct _GMencoder GMencoder;
typedef struct _GMencoderClass GMencoderClass;

struct _GMencoderClass {
    GObjectClass    parent_class;
};

struct _GMencoder {
    GObject         parent;
};

/*
 * TYPE MACROS 
 */
#define G_TYPE_MENCODER \
  (g_mencoder_get_type())
#define G_MENCODER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_MENCODER, GMencoder))
#define G_MENCODER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_MENCODER, GMencoderClass))
#define G_IS_MENCODER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_MENCODER))
#define G_IS_MENCODER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_MENCODER))
#define G_MENCODER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS ((obj), G_TYPE_MENCODER, GMencoderClass))


GType           g_mencoder_get_type(void);
GMencoder      *g_mencoder_new(void);

gboolean        g_mencoder_setup_stream(GMencoder * self,
					gboolean chunked,
					gboolean deinterlace,
                                        const gchar * mux_name,
                                        const gchar * video_encode,
                                        gchar ** video_encode_prop,
                                        gdouble video_fps,
                                        gdouble video_rate,
                                        guint video_width,
                                        guint video_height,
                                        const gchar * audio_encode,
                                        gchar ** audio_encode_prop,
                                        guint audio_rate,
                                        const gchar * output_uri);

gboolean        g_mencoder_append_uri(GMencoder * self, const gchar * uri);

void            g_mencoder_remove_uri(GMencoder * self, const gchar * uri);

void            g_mencoder_play_stream(GMencoder * self);
void            g_mencoder_pause_stream(GMencoder * self);
void            g_mencoder_close_stream(GMencoder * self);

G_END_DECLS
#endif
